package strathclyde.cs.relational.operators;
import strathclyde.cs.relational.*;

/*
 *
 * NDreduce
 *
 Reduces a <niladic><dyadic> pair to a <monadic>
 as in x +  where x is niladic
 */
public class NDreduce extends Moperator
{	Niladic n; Doperator d;
	private boolean left;
	public NDreduce(Niladic op1, Doperator op2)
	{ n=op1;d=op2;left=true;}
	public NDreduce( Doperator op2,Niladic op1)
	{ n=op1;d=op2;left=false;}
	public Universal apply(Universal b)
	{ return (left?d.apply(n.eval(),b):d.apply(b,n.eval()));}
	public String toString()
	{ return (left?" "+n+" "+d:" "+d+n);}


}

