//package operator;

/*
 *
 * niladic
 * Part of Mbase implemented in Java
  Author Paul Cockshott
  Started Aug 1997
  Copyright (c) University of strathclyde

 */
package strathclyde.cs.relational.operators;
import strathclyde.cs.relational.Universal;


public abstract class Niladic  implements Universal
{
public abstract Universal eval();
 	public  Universal plus (Universal b)/**TeX implements $+$ */
	{return eval().plus(b);}
	public Universal concat (Universal b)/**TeX implements $++$ */
	{return eval().concat(b);}
	public  Universal minus (Universal b)/**TeX implements $-$ */
	{return eval().minus(b);}
	public  Universal times (Universal b)/**TeX implements $\times$ */
	{return eval().times(b);}
	public  Universal divide (Universal b)/**TeX implements $\div$ */
	{ return eval().divide(b);}
	public  Universal max (Universal b)
	{return (lessthan(b)?b:this);}
	public  Universal min (Universal b)
	{return (lessthan(b)?this:b);}
	public  boolean lessthan (Universal b)
	{ return eval().lessthan(b);}
	public  int hashCode(){return eval().hashCode();}
}

