package strathclyde.cs.relational.operators;
import strathclyde.cs.relational.*;
import strathclyde.cs.relational.structured.*;
/*
 *
 * Select
 *
 implements the selection operator on sets
 */
public class Select extends Moperator
{
	Moperator pred;
	public Select(Moperator predicate){pred=predicate;}
	public Universal apply(Universal u)
	{ 
		if (u instanceof Set)
			return ((Set)u).select(pred);
		else return Universal.undefinedValue;
	}
	public String toString(){return "(|"+pred+")";}	
}

