package strathclyde.cs.relational.operators;
import strathclyde.cs.relational.structured.*;
import strathclyde.cs.relational.atomic.*;
import strathclyde.cs.relational.*;
import Plus;

/*
 *
 * Wadd
 *
 */
public class Wadd extends Plus
{
	Number wt;
	public Wadd(){wt = new Numeric(0.5);}
	public Wadd(Number n){wt=n;}
  	public  Universal apply(Universal a,Universal b)
	{ if (a instanceof Wset){
		Wset wa= (Wset)a;
		return wa.plus(wt,b);
	}
	return a.plus(b);
	}

	public String toString(){ return ":+"+wt+" ";} 

}

